#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private SpeculatorSeth.spsAdvCumulativeDelta[] cachespsAdvCumulativeDelta;
		private SpeculatorSeth.spsAlice[] cachespsAlice;
		private SpeculatorSeth.spsInventoryCostBasis[] cachespsInventoryCostBasis;
		private SpeculatorSeth.spsKalman[] cachespsKalman;
		private SpeculatorSeth.spsLargestRestingOrders[] cachespsLargestRestingOrders;
		private SpeculatorSeth.spsLevel2Changes[] cachespsLevel2Changes;
		private SpeculatorSeth.spsMultiATR[] cachespsMultiATR;
		private SpeculatorSeth.spsPulledPrices[] cachespsPulledPrices;
		private SpeculatorSeth.spsRangeHistogram[] cachespsRangeHistogram;
		private SpeculatorSeth.spsRestingOrders[] cachespsRestingOrders;
		private SpeculatorSeth.spsSpread[] cachespsSpread;
		private SpeculatorSeth.spsSpreadCandles[] cachespsSpreadCandles;
		private SpeculatorSeth.spsSyntheticDollarIndex[] cachespsSyntheticDollarIndex;
		private SpeculatorSeth.spsSyntheticDollarIndexCandles[] cachespsSyntheticDollarIndexCandles;
		private SpeculatorSeth.spsVolatilityProjectedRange[] cachespsVolatilityProjectedRange;
		private SpeculatorSethFree.spsYieldCurve[] cachespsYieldCurve;
		private SpeculatorSeth.Alpha.spsBidAskSpread[] cachespsBidAskSpread;

		
		public SpeculatorSeth.spsAdvCumulativeDelta spsAdvCumulativeDelta(SpSTimeframe resetDeltaOn)
		{
			return spsAdvCumulativeDelta(Input, resetDeltaOn);
		}

		public SpeculatorSeth.spsAlice spsAlice(int period, double target)
		{
			return spsAlice(Input, period, target);
		}

		public SpeculatorSeth.spsInventoryCostBasis spsInventoryCostBasis(bool isCumulative, bool resetOnSession)
		{
			return spsInventoryCostBasis(Input, isCumulative, resetOnSession);
		}

		public SpeculatorSeth.spsKalman spsKalman(double gain)
		{
			return spsKalman(Input, gain);
		}

		public SpeculatorSeth.spsLargestRestingOrders spsLargestRestingOrders(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return spsLargestRestingOrders(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public SpeculatorSeth.spsLevel2Changes spsLevel2Changes(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return spsLevel2Changes(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public SpeculatorSeth.spsMultiATR spsMultiATR(int period)
		{
			return spsMultiATR(Input, period);
		}

		public SpeculatorSeth.spsPulledPrices spsPulledPrices(int gap, long size)
		{
			return spsPulledPrices(Input, gap, size);
		}

		public SpeculatorSeth.spsRangeHistogram spsRangeHistogram(bool useLog, bool useArea, bool limitByDayOfWeek, System.DayOfWeek week, double valueAreaPercent, Brush normalColor, Brush valueColor, int textSize, Brush textColor)
		{
			return spsRangeHistogram(Input, useLog, useArea, limitByDayOfWeek, week, valueAreaPercent, normalColor, valueColor, textSize, textColor);
		}

		public SpeculatorSeth.spsRestingOrders spsRestingOrders(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter)
		{
			return spsRestingOrders(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter);
		}

		public SpeculatorSeth.spsSpread spsSpread(string leg0, int ratio0, string leg1, int ratio1, string leg2, int ratio2, string leg3, int ratio3, string leg4, int ratio4, bool userProvidesMonth, int number, bool grayHistorical)
		{
			return spsSpread(Input, leg0, ratio0, leg1, ratio1, leg2, ratio2, leg3, ratio3, leg4, ratio4, userProvidesMonth, number, grayHistorical);
		}

		public SpeculatorSeth.spsSpreadCandles spsSpreadCandles(string frontLeg, double frontRatio, string backLeg, double backRatio, bool userProvidesMonth, bool grayHistorical)
		{
			return spsSpreadCandles(Input, frontLeg, frontRatio, backLeg, backRatio, userProvidesMonth, grayHistorical);
		}

		public SpeculatorSeth.spsSyntheticDollarIndex spsSyntheticDollarIndex()
		{
			return spsSyntheticDollarIndex(Input);
		}

		public SpeculatorSeth.spsSyntheticDollarIndexCandles spsSyntheticDollarIndexCandles(bool grayHistorical)
		{
			return spsSyntheticDollarIndexCandles(Input, grayHistorical);
		}

		public SpeculatorSeth.spsVolatilityProjectedRange spsVolatilityProjectedRange()
		{
			return spsVolatilityProjectedRange(Input);
		}

		public SpeculatorSethFree.spsYieldCurve spsYieldCurve(string expiry)
		{
			return spsYieldCurve(Input, expiry);
		}

		public SpeculatorSeth.Alpha.spsBidAskSpread spsBidAskSpread()
		{
			return spsBidAskSpread(Input);
		}


		
		public SpeculatorSeth.spsAdvCumulativeDelta spsAdvCumulativeDelta(ISeries<double> input, SpSTimeframe resetDeltaOn)
		{
			if (cachespsAdvCumulativeDelta != null)
				for (int idx = 0; idx < cachespsAdvCumulativeDelta.Length; idx++)
					if (cachespsAdvCumulativeDelta[idx].ResetDeltaOn == resetDeltaOn && cachespsAdvCumulativeDelta[idx].EqualsInput(input))
						return cachespsAdvCumulativeDelta[idx];
			return CacheIndicator<SpeculatorSeth.spsAdvCumulativeDelta>(new SpeculatorSeth.spsAdvCumulativeDelta(){ ResetDeltaOn = resetDeltaOn }, input, ref cachespsAdvCumulativeDelta);
		}

		public SpeculatorSeth.spsAlice spsAlice(ISeries<double> input, int period, double target)
		{
			if (cachespsAlice != null)
				for (int idx = 0; idx < cachespsAlice.Length; idx++)
					if (cachespsAlice[idx].Period == period && cachespsAlice[idx].Target == target && cachespsAlice[idx].EqualsInput(input))
						return cachespsAlice[idx];
			return CacheIndicator<SpeculatorSeth.spsAlice>(new SpeculatorSeth.spsAlice(){ Period = period, Target = target }, input, ref cachespsAlice);
		}

		public SpeculatorSeth.spsInventoryCostBasis spsInventoryCostBasis(ISeries<double> input, bool isCumulative, bool resetOnSession)
		{
			if (cachespsInventoryCostBasis != null)
				for (int idx = 0; idx < cachespsInventoryCostBasis.Length; idx++)
					if (cachespsInventoryCostBasis[idx].IsCumulative == isCumulative && cachespsInventoryCostBasis[idx].ResetOnSession == resetOnSession && cachespsInventoryCostBasis[idx].EqualsInput(input))
						return cachespsInventoryCostBasis[idx];
			return CacheIndicator<SpeculatorSeth.spsInventoryCostBasis>(new SpeculatorSeth.spsInventoryCostBasis(){ IsCumulative = isCumulative, ResetOnSession = resetOnSession }, input, ref cachespsInventoryCostBasis);
		}

		public SpeculatorSeth.spsKalman spsKalman(ISeries<double> input, double gain)
		{
			if (cachespsKalman != null)
				for (int idx = 0; idx < cachespsKalman.Length; idx++)
					if (cachespsKalman[idx].Gain == gain && cachespsKalman[idx].EqualsInput(input))
						return cachespsKalman[idx];
			return CacheIndicator<SpeculatorSeth.spsKalman>(new SpeculatorSeth.spsKalman(){ Gain = gain }, input, ref cachespsKalman);
		}

		public SpeculatorSeth.spsLargestRestingOrders spsLargestRestingOrders(ISeries<double> input, int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			if (cachespsLargestRestingOrders != null)
				for (int idx = 0; idx < cachespsLargestRestingOrders.Length; idx++)
					if (cachespsLargestRestingOrders[idx].MinFilter == minFilter && cachespsLargestRestingOrders[idx].MaxFilter == maxFilter && cachespsLargestRestingOrders[idx].MinLevelFilter == minLevelFilter && cachespsLargestRestingOrders[idx].MaxLevelFilter == maxLevelFilter && cachespsLargestRestingOrders[idx].ShowBids == showBids && cachespsLargestRestingOrders[idx].ShowOffers == showOffers && cachespsLargestRestingOrders[idx].EqualsInput(input))
						return cachespsLargestRestingOrders[idx];
			return CacheIndicator<SpeculatorSeth.spsLargestRestingOrders>(new SpeculatorSeth.spsLargestRestingOrders(){ MinFilter = minFilter, MaxFilter = maxFilter, MinLevelFilter = minLevelFilter, MaxLevelFilter = maxLevelFilter, ShowBids = showBids, ShowOffers = showOffers }, input, ref cachespsLargestRestingOrders);
		}

		public SpeculatorSeth.spsLevel2Changes spsLevel2Changes(ISeries<double> input, int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			if (cachespsLevel2Changes != null)
				for (int idx = 0; idx < cachespsLevel2Changes.Length; idx++)
					if (cachespsLevel2Changes[idx].MinFilter == minFilter && cachespsLevel2Changes[idx].MaxFilter == maxFilter && cachespsLevel2Changes[idx].MinLevelFilter == minLevelFilter && cachespsLevel2Changes[idx].MaxLevelFilter == maxLevelFilter && cachespsLevel2Changes[idx].ShowBids == showBids && cachespsLevel2Changes[idx].ShowOffers == showOffers && cachespsLevel2Changes[idx].EqualsInput(input))
						return cachespsLevel2Changes[idx];
			return CacheIndicator<SpeculatorSeth.spsLevel2Changes>(new SpeculatorSeth.spsLevel2Changes(){ MinFilter = minFilter, MaxFilter = maxFilter, MinLevelFilter = minLevelFilter, MaxLevelFilter = maxLevelFilter, ShowBids = showBids, ShowOffers = showOffers }, input, ref cachespsLevel2Changes);
		}

		public SpeculatorSeth.spsMultiATR spsMultiATR(ISeries<double> input, int period)
		{
			if (cachespsMultiATR != null)
				for (int idx = 0; idx < cachespsMultiATR.Length; idx++)
					if (cachespsMultiATR[idx].Period == period && cachespsMultiATR[idx].EqualsInput(input))
						return cachespsMultiATR[idx];
			return CacheIndicator<SpeculatorSeth.spsMultiATR>(new SpeculatorSeth.spsMultiATR(){ Period = period }, input, ref cachespsMultiATR);
		}

		public SpeculatorSeth.spsPulledPrices spsPulledPrices(ISeries<double> input, int gap, long size)
		{
			if (cachespsPulledPrices != null)
				for (int idx = 0; idx < cachespsPulledPrices.Length; idx++)
					if (cachespsPulledPrices[idx].Gap == gap && cachespsPulledPrices[idx].Size == size && cachespsPulledPrices[idx].EqualsInput(input))
						return cachespsPulledPrices[idx];
			return CacheIndicator<SpeculatorSeth.spsPulledPrices>(new SpeculatorSeth.spsPulledPrices(){ Gap = gap, Size = size }, input, ref cachespsPulledPrices);
		}

		public SpeculatorSeth.spsRangeHistogram spsRangeHistogram(ISeries<double> input, bool useLog, bool useArea, bool limitByDayOfWeek, System.DayOfWeek week, double valueAreaPercent, Brush normalColor, Brush valueColor, int textSize, Brush textColor)
		{
			if (cachespsRangeHistogram != null)
				for (int idx = 0; idx < cachespsRangeHistogram.Length; idx++)
					if (cachespsRangeHistogram[idx].UseLog == useLog && cachespsRangeHistogram[idx].UseArea == useArea && cachespsRangeHistogram[idx].LimitByDayOfWeek == limitByDayOfWeek && cachespsRangeHistogram[idx].Week == week && cachespsRangeHistogram[idx].ValueAreaPercent == valueAreaPercent && cachespsRangeHistogram[idx].NormalColor == normalColor && cachespsRangeHistogram[idx].ValueColor == valueColor && cachespsRangeHistogram[idx].textSize == textSize && cachespsRangeHistogram[idx].TextColor == textColor && cachespsRangeHistogram[idx].EqualsInput(input))
						return cachespsRangeHistogram[idx];
			return CacheIndicator<SpeculatorSeth.spsRangeHistogram>(new SpeculatorSeth.spsRangeHistogram(){ UseLog = useLog, UseArea = useArea, LimitByDayOfWeek = limitByDayOfWeek, Week = week, ValueAreaPercent = valueAreaPercent, NormalColor = normalColor, ValueColor = valueColor, textSize = textSize, TextColor = textColor }, input, ref cachespsRangeHistogram);
		}

		public SpeculatorSeth.spsRestingOrders spsRestingOrders(ISeries<double> input, int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter)
		{
			if (cachespsRestingOrders != null)
				for (int idx = 0; idx < cachespsRestingOrders.Length; idx++)
					if (cachespsRestingOrders[idx].MinFilter == minFilter && cachespsRestingOrders[idx].MaxFilter == maxFilter && cachespsRestingOrders[idx].MinLevelFilter == minLevelFilter && cachespsRestingOrders[idx].MaxLevelFilter == maxLevelFilter && cachespsRestingOrders[idx].EqualsInput(input))
						return cachespsRestingOrders[idx];
			return CacheIndicator<SpeculatorSeth.spsRestingOrders>(new SpeculatorSeth.spsRestingOrders(){ MinFilter = minFilter, MaxFilter = maxFilter, MinLevelFilter = minLevelFilter, MaxLevelFilter = maxLevelFilter }, input, ref cachespsRestingOrders);
		}

		public SpeculatorSeth.spsSpread spsSpread(ISeries<double> input, string leg0, int ratio0, string leg1, int ratio1, string leg2, int ratio2, string leg3, int ratio3, string leg4, int ratio4, bool userProvidesMonth, int number, bool grayHistorical)
		{
			if (cachespsSpread != null)
				for (int idx = 0; idx < cachespsSpread.Length; idx++)
					if (cachespsSpread[idx].Leg0 == leg0 && cachespsSpread[idx].Ratio0 == ratio0 && cachespsSpread[idx].Leg1 == leg1 && cachespsSpread[idx].Ratio1 == ratio1 && cachespsSpread[idx].Leg2 == leg2 && cachespsSpread[idx].Ratio2 == ratio2 && cachespsSpread[idx].Leg3 == leg3 && cachespsSpread[idx].Ratio3 == ratio3 && cachespsSpread[idx].Leg4 == leg4 && cachespsSpread[idx].Ratio4 == ratio4 && cachespsSpread[idx].UserProvidesMonth == userProvidesMonth && cachespsSpread[idx].Number == number && cachespsSpread[idx].GrayHistorical == grayHistorical && cachespsSpread[idx].EqualsInput(input))
						return cachespsSpread[idx];
			return CacheIndicator<SpeculatorSeth.spsSpread>(new SpeculatorSeth.spsSpread(){ Leg0 = leg0, Ratio0 = ratio0, Leg1 = leg1, Ratio1 = ratio1, Leg2 = leg2, Ratio2 = ratio2, Leg3 = leg3, Ratio3 = ratio3, Leg4 = leg4, Ratio4 = ratio4, UserProvidesMonth = userProvidesMonth, Number = number, GrayHistorical = grayHistorical }, input, ref cachespsSpread);
		}

		public SpeculatorSeth.spsSpreadCandles spsSpreadCandles(ISeries<double> input, string frontLeg, double frontRatio, string backLeg, double backRatio, bool userProvidesMonth, bool grayHistorical)
		{
			if (cachespsSpreadCandles != null)
				for (int idx = 0; idx < cachespsSpreadCandles.Length; idx++)
					if (cachespsSpreadCandles[idx].FrontLeg == frontLeg && cachespsSpreadCandles[idx].FrontRatio == frontRatio && cachespsSpreadCandles[idx].BackLeg == backLeg && cachespsSpreadCandles[idx].BackRatio == backRatio && cachespsSpreadCandles[idx].UserProvidesMonth == userProvidesMonth && cachespsSpreadCandles[idx].GrayHistorical == grayHistorical && cachespsSpreadCandles[idx].EqualsInput(input))
						return cachespsSpreadCandles[idx];
			return CacheIndicator<SpeculatorSeth.spsSpreadCandles>(new SpeculatorSeth.spsSpreadCandles(){ FrontLeg = frontLeg, FrontRatio = frontRatio, BackLeg = backLeg, BackRatio = backRatio, UserProvidesMonth = userProvidesMonth, GrayHistorical = grayHistorical }, input, ref cachespsSpreadCandles);
		}

		public SpeculatorSeth.spsSyntheticDollarIndex spsSyntheticDollarIndex(ISeries<double> input)
		{
			if (cachespsSyntheticDollarIndex != null)
				for (int idx = 0; idx < cachespsSyntheticDollarIndex.Length; idx++)
					if ( cachespsSyntheticDollarIndex[idx].EqualsInput(input))
						return cachespsSyntheticDollarIndex[idx];
			return CacheIndicator<SpeculatorSeth.spsSyntheticDollarIndex>(new SpeculatorSeth.spsSyntheticDollarIndex(), input, ref cachespsSyntheticDollarIndex);
		}

		public SpeculatorSeth.spsSyntheticDollarIndexCandles spsSyntheticDollarIndexCandles(ISeries<double> input, bool grayHistorical)
		{
			if (cachespsSyntheticDollarIndexCandles != null)
				for (int idx = 0; idx < cachespsSyntheticDollarIndexCandles.Length; idx++)
					if (cachespsSyntheticDollarIndexCandles[idx].GrayHistorical == grayHistorical && cachespsSyntheticDollarIndexCandles[idx].EqualsInput(input))
						return cachespsSyntheticDollarIndexCandles[idx];
			return CacheIndicator<SpeculatorSeth.spsSyntheticDollarIndexCandles>(new SpeculatorSeth.spsSyntheticDollarIndexCandles(){ GrayHistorical = grayHistorical }, input, ref cachespsSyntheticDollarIndexCandles);
		}

		public SpeculatorSeth.spsVolatilityProjectedRange spsVolatilityProjectedRange(ISeries<double> input)
		{
			if (cachespsVolatilityProjectedRange != null)
				for (int idx = 0; idx < cachespsVolatilityProjectedRange.Length; idx++)
					if ( cachespsVolatilityProjectedRange[idx].EqualsInput(input))
						return cachespsVolatilityProjectedRange[idx];
			return CacheIndicator<SpeculatorSeth.spsVolatilityProjectedRange>(new SpeculatorSeth.spsVolatilityProjectedRange(), input, ref cachespsVolatilityProjectedRange);
		}

		public SpeculatorSethFree.spsYieldCurve spsYieldCurve(ISeries<double> input, string expiry)
		{
			if (cachespsYieldCurve != null)
				for (int idx = 0; idx < cachespsYieldCurve.Length; idx++)
					if (cachespsYieldCurve[idx].Expiry == expiry && cachespsYieldCurve[idx].EqualsInput(input))
						return cachespsYieldCurve[idx];
			return CacheIndicator<SpeculatorSethFree.spsYieldCurve>(new SpeculatorSethFree.spsYieldCurve(){ Expiry = expiry }, input, ref cachespsYieldCurve);
		}

		public SpeculatorSeth.Alpha.spsBidAskSpread spsBidAskSpread(ISeries<double> input)
		{
			if (cachespsBidAskSpread != null)
				for (int idx = 0; idx < cachespsBidAskSpread.Length; idx++)
					if ( cachespsBidAskSpread[idx].EqualsInput(input))
						return cachespsBidAskSpread[idx];
			return CacheIndicator<SpeculatorSeth.Alpha.spsBidAskSpread>(new SpeculatorSeth.Alpha.spsBidAskSpread(), input, ref cachespsBidAskSpread);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.SpeculatorSeth.spsAdvCumulativeDelta spsAdvCumulativeDelta(SpSTimeframe resetDeltaOn)
		{
			return indicator.spsAdvCumulativeDelta(Input, resetDeltaOn);
		}

		public Indicators.SpeculatorSeth.spsAlice spsAlice(int period, double target)
		{
			return indicator.spsAlice(Input, period, target);
		}

		public Indicators.SpeculatorSeth.spsInventoryCostBasis spsInventoryCostBasis(bool isCumulative, bool resetOnSession)
		{
			return indicator.spsInventoryCostBasis(Input, isCumulative, resetOnSession);
		}

		public Indicators.SpeculatorSeth.spsKalman spsKalman(double gain)
		{
			return indicator.spsKalman(Input, gain);
		}

		public Indicators.SpeculatorSeth.spsLargestRestingOrders spsLargestRestingOrders(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return indicator.spsLargestRestingOrders(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public Indicators.SpeculatorSeth.spsLevel2Changes spsLevel2Changes(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return indicator.spsLevel2Changes(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public Indicators.SpeculatorSeth.spsMultiATR spsMultiATR(int period)
		{
			return indicator.spsMultiATR(Input, period);
		}

		public Indicators.SpeculatorSeth.spsPulledPrices spsPulledPrices(int gap, long size)
		{
			return indicator.spsPulledPrices(Input, gap, size);
		}

		public Indicators.SpeculatorSeth.spsRangeHistogram spsRangeHistogram(bool useLog, bool useArea, bool limitByDayOfWeek, System.DayOfWeek week, double valueAreaPercent, Brush normalColor, Brush valueColor, int textSize, Brush textColor)
		{
			return indicator.spsRangeHistogram(Input, useLog, useArea, limitByDayOfWeek, week, valueAreaPercent, normalColor, valueColor, textSize, textColor);
		}

		public Indicators.SpeculatorSeth.spsRestingOrders spsRestingOrders(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter)
		{
			return indicator.spsRestingOrders(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter);
		}

		public Indicators.SpeculatorSeth.spsSpread spsSpread(string leg0, int ratio0, string leg1, int ratio1, string leg2, int ratio2, string leg3, int ratio3, string leg4, int ratio4, bool userProvidesMonth, int number, bool grayHistorical)
		{
			return indicator.spsSpread(Input, leg0, ratio0, leg1, ratio1, leg2, ratio2, leg3, ratio3, leg4, ratio4, userProvidesMonth, number, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsSpreadCandles spsSpreadCandles(string frontLeg, double frontRatio, string backLeg, double backRatio, bool userProvidesMonth, bool grayHistorical)
		{
			return indicator.spsSpreadCandles(Input, frontLeg, frontRatio, backLeg, backRatio, userProvidesMonth, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsSyntheticDollarIndex spsSyntheticDollarIndex()
		{
			return indicator.spsSyntheticDollarIndex(Input);
		}

		public Indicators.SpeculatorSeth.spsSyntheticDollarIndexCandles spsSyntheticDollarIndexCandles(bool grayHistorical)
		{
			return indicator.spsSyntheticDollarIndexCandles(Input, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsVolatilityProjectedRange spsVolatilityProjectedRange()
		{
			return indicator.spsVolatilityProjectedRange(Input);
		}

		public Indicators.SpeculatorSethFree.spsYieldCurve spsYieldCurve(string expiry)
		{
			return indicator.spsYieldCurve(Input, expiry);
		}

		public Indicators.SpeculatorSeth.Alpha.spsBidAskSpread spsBidAskSpread()
		{
			return indicator.spsBidAskSpread(Input);
		}


		
		public Indicators.SpeculatorSeth.spsAdvCumulativeDelta spsAdvCumulativeDelta(ISeries<double> input , SpSTimeframe resetDeltaOn)
		{
			return indicator.spsAdvCumulativeDelta(input, resetDeltaOn);
		}

		public Indicators.SpeculatorSeth.spsAlice spsAlice(ISeries<double> input , int period, double target)
		{
			return indicator.spsAlice(input, period, target);
		}

		public Indicators.SpeculatorSeth.spsInventoryCostBasis spsInventoryCostBasis(ISeries<double> input , bool isCumulative, bool resetOnSession)
		{
			return indicator.spsInventoryCostBasis(input, isCumulative, resetOnSession);
		}

		public Indicators.SpeculatorSeth.spsKalman spsKalman(ISeries<double> input , double gain)
		{
			return indicator.spsKalman(input, gain);
		}

		public Indicators.SpeculatorSeth.spsLargestRestingOrders spsLargestRestingOrders(ISeries<double> input , int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return indicator.spsLargestRestingOrders(input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public Indicators.SpeculatorSeth.spsLevel2Changes spsLevel2Changes(ISeries<double> input , int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return indicator.spsLevel2Changes(input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public Indicators.SpeculatorSeth.spsMultiATR spsMultiATR(ISeries<double> input , int period)
		{
			return indicator.spsMultiATR(input, period);
		}

		public Indicators.SpeculatorSeth.spsPulledPrices spsPulledPrices(ISeries<double> input , int gap, long size)
		{
			return indicator.spsPulledPrices(input, gap, size);
		}

		public Indicators.SpeculatorSeth.spsRangeHistogram spsRangeHistogram(ISeries<double> input , bool useLog, bool useArea, bool limitByDayOfWeek, System.DayOfWeek week, double valueAreaPercent, Brush normalColor, Brush valueColor, int textSize, Brush textColor)
		{
			return indicator.spsRangeHistogram(input, useLog, useArea, limitByDayOfWeek, week, valueAreaPercent, normalColor, valueColor, textSize, textColor);
		}

		public Indicators.SpeculatorSeth.spsRestingOrders spsRestingOrders(ISeries<double> input , int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter)
		{
			return indicator.spsRestingOrders(input, minFilter, maxFilter, minLevelFilter, maxLevelFilter);
		}

		public Indicators.SpeculatorSeth.spsSpread spsSpread(ISeries<double> input , string leg0, int ratio0, string leg1, int ratio1, string leg2, int ratio2, string leg3, int ratio3, string leg4, int ratio4, bool userProvidesMonth, int number, bool grayHistorical)
		{
			return indicator.spsSpread(input, leg0, ratio0, leg1, ratio1, leg2, ratio2, leg3, ratio3, leg4, ratio4, userProvidesMonth, number, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsSpreadCandles spsSpreadCandles(ISeries<double> input , string frontLeg, double frontRatio, string backLeg, double backRatio, bool userProvidesMonth, bool grayHistorical)
		{
			return indicator.spsSpreadCandles(input, frontLeg, frontRatio, backLeg, backRatio, userProvidesMonth, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsSyntheticDollarIndex spsSyntheticDollarIndex(ISeries<double> input )
		{
			return indicator.spsSyntheticDollarIndex(input);
		}

		public Indicators.SpeculatorSeth.spsSyntheticDollarIndexCandles spsSyntheticDollarIndexCandles(ISeries<double> input , bool grayHistorical)
		{
			return indicator.spsSyntheticDollarIndexCandles(input, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsVolatilityProjectedRange spsVolatilityProjectedRange(ISeries<double> input )
		{
			return indicator.spsVolatilityProjectedRange(input);
		}

		public Indicators.SpeculatorSethFree.spsYieldCurve spsYieldCurve(ISeries<double> input , string expiry)
		{
			return indicator.spsYieldCurve(input, expiry);
		}

		public Indicators.SpeculatorSeth.Alpha.spsBidAskSpread spsBidAskSpread(ISeries<double> input )
		{
			return indicator.spsBidAskSpread(input);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.SpeculatorSeth.spsAdvCumulativeDelta spsAdvCumulativeDelta(SpSTimeframe resetDeltaOn)
		{
			return indicator.spsAdvCumulativeDelta(Input, resetDeltaOn);
		}

		public Indicators.SpeculatorSeth.spsAlice spsAlice(int period, double target)
		{
			return indicator.spsAlice(Input, period, target);
		}

		public Indicators.SpeculatorSeth.spsInventoryCostBasis spsInventoryCostBasis(bool isCumulative, bool resetOnSession)
		{
			return indicator.spsInventoryCostBasis(Input, isCumulative, resetOnSession);
		}

		public Indicators.SpeculatorSeth.spsKalman spsKalman(double gain)
		{
			return indicator.spsKalman(Input, gain);
		}

		public Indicators.SpeculatorSeth.spsLargestRestingOrders spsLargestRestingOrders(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return indicator.spsLargestRestingOrders(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public Indicators.SpeculatorSeth.spsLevel2Changes spsLevel2Changes(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return indicator.spsLevel2Changes(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public Indicators.SpeculatorSeth.spsMultiATR spsMultiATR(int period)
		{
			return indicator.spsMultiATR(Input, period);
		}

		public Indicators.SpeculatorSeth.spsPulledPrices spsPulledPrices(int gap, long size)
		{
			return indicator.spsPulledPrices(Input, gap, size);
		}

		public Indicators.SpeculatorSeth.spsRangeHistogram spsRangeHistogram(bool useLog, bool useArea, bool limitByDayOfWeek, System.DayOfWeek week, double valueAreaPercent, Brush normalColor, Brush valueColor, int textSize, Brush textColor)
		{
			return indicator.spsRangeHistogram(Input, useLog, useArea, limitByDayOfWeek, week, valueAreaPercent, normalColor, valueColor, textSize, textColor);
		}

		public Indicators.SpeculatorSeth.spsRestingOrders spsRestingOrders(int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter)
		{
			return indicator.spsRestingOrders(Input, minFilter, maxFilter, minLevelFilter, maxLevelFilter);
		}

		public Indicators.SpeculatorSeth.spsSpread spsSpread(string leg0, int ratio0, string leg1, int ratio1, string leg2, int ratio2, string leg3, int ratio3, string leg4, int ratio4, bool userProvidesMonth, int number, bool grayHistorical)
		{
			return indicator.spsSpread(Input, leg0, ratio0, leg1, ratio1, leg2, ratio2, leg3, ratio3, leg4, ratio4, userProvidesMonth, number, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsSpreadCandles spsSpreadCandles(string frontLeg, double frontRatio, string backLeg, double backRatio, bool userProvidesMonth, bool grayHistorical)
		{
			return indicator.spsSpreadCandles(Input, frontLeg, frontRatio, backLeg, backRatio, userProvidesMonth, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsSyntheticDollarIndex spsSyntheticDollarIndex()
		{
			return indicator.spsSyntheticDollarIndex(Input);
		}

		public Indicators.SpeculatorSeth.spsSyntheticDollarIndexCandles spsSyntheticDollarIndexCandles(bool grayHistorical)
		{
			return indicator.spsSyntheticDollarIndexCandles(Input, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsVolatilityProjectedRange spsVolatilityProjectedRange()
		{
			return indicator.spsVolatilityProjectedRange(Input);
		}

		public Indicators.SpeculatorSethFree.spsYieldCurve spsYieldCurve(string expiry)
		{
			return indicator.spsYieldCurve(Input, expiry);
		}

		public Indicators.SpeculatorSeth.Alpha.spsBidAskSpread spsBidAskSpread()
		{
			return indicator.spsBidAskSpread(Input);
		}


		
		public Indicators.SpeculatorSeth.spsAdvCumulativeDelta spsAdvCumulativeDelta(ISeries<double> input , SpSTimeframe resetDeltaOn)
		{
			return indicator.spsAdvCumulativeDelta(input, resetDeltaOn);
		}

		public Indicators.SpeculatorSeth.spsAlice spsAlice(ISeries<double> input , int period, double target)
		{
			return indicator.spsAlice(input, period, target);
		}

		public Indicators.SpeculatorSeth.spsInventoryCostBasis spsInventoryCostBasis(ISeries<double> input , bool isCumulative, bool resetOnSession)
		{
			return indicator.spsInventoryCostBasis(input, isCumulative, resetOnSession);
		}

		public Indicators.SpeculatorSeth.spsKalman spsKalman(ISeries<double> input , double gain)
		{
			return indicator.spsKalman(input, gain);
		}

		public Indicators.SpeculatorSeth.spsLargestRestingOrders spsLargestRestingOrders(ISeries<double> input , int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return indicator.spsLargestRestingOrders(input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public Indicators.SpeculatorSeth.spsLevel2Changes spsLevel2Changes(ISeries<double> input , int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter, bool showBids, bool showOffers)
		{
			return indicator.spsLevel2Changes(input, minFilter, maxFilter, minLevelFilter, maxLevelFilter, showBids, showOffers);
		}

		public Indicators.SpeculatorSeth.spsMultiATR spsMultiATR(ISeries<double> input , int period)
		{
			return indicator.spsMultiATR(input, period);
		}

		public Indicators.SpeculatorSeth.spsPulledPrices spsPulledPrices(ISeries<double> input , int gap, long size)
		{
			return indicator.spsPulledPrices(input, gap, size);
		}

		public Indicators.SpeculatorSeth.spsRangeHistogram spsRangeHistogram(ISeries<double> input , bool useLog, bool useArea, bool limitByDayOfWeek, System.DayOfWeek week, double valueAreaPercent, Brush normalColor, Brush valueColor, int textSize, Brush textColor)
		{
			return indicator.spsRangeHistogram(input, useLog, useArea, limitByDayOfWeek, week, valueAreaPercent, normalColor, valueColor, textSize, textColor);
		}

		public Indicators.SpeculatorSeth.spsRestingOrders spsRestingOrders(ISeries<double> input , int minFilter, int maxFilter, int minLevelFilter, int maxLevelFilter)
		{
			return indicator.spsRestingOrders(input, minFilter, maxFilter, minLevelFilter, maxLevelFilter);
		}

		public Indicators.SpeculatorSeth.spsSpread spsSpread(ISeries<double> input , string leg0, int ratio0, string leg1, int ratio1, string leg2, int ratio2, string leg3, int ratio3, string leg4, int ratio4, bool userProvidesMonth, int number, bool grayHistorical)
		{
			return indicator.spsSpread(input, leg0, ratio0, leg1, ratio1, leg2, ratio2, leg3, ratio3, leg4, ratio4, userProvidesMonth, number, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsSpreadCandles spsSpreadCandles(ISeries<double> input , string frontLeg, double frontRatio, string backLeg, double backRatio, bool userProvidesMonth, bool grayHistorical)
		{
			return indicator.spsSpreadCandles(input, frontLeg, frontRatio, backLeg, backRatio, userProvidesMonth, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsSyntheticDollarIndex spsSyntheticDollarIndex(ISeries<double> input )
		{
			return indicator.spsSyntheticDollarIndex(input);
		}

		public Indicators.SpeculatorSeth.spsSyntheticDollarIndexCandles spsSyntheticDollarIndexCandles(ISeries<double> input , bool grayHistorical)
		{
			return indicator.spsSyntheticDollarIndexCandles(input, grayHistorical);
		}

		public Indicators.SpeculatorSeth.spsVolatilityProjectedRange spsVolatilityProjectedRange(ISeries<double> input )
		{
			return indicator.spsVolatilityProjectedRange(input);
		}

		public Indicators.SpeculatorSethFree.spsYieldCurve spsYieldCurve(ISeries<double> input , string expiry)
		{
			return indicator.spsYieldCurve(input, expiry);
		}

		public Indicators.SpeculatorSeth.Alpha.spsBidAskSpread spsBidAskSpread(ISeries<double> input )
		{
			return indicator.spsBidAskSpread(input);
		}

	}
}

#endregion
